#ifndef CRUMAINWINDOW_H
#define CRUMAINWINDOW_H

#include "lib-common/BaseDeviceAppConfig.h"
#include "lib-common/ReadoutAppMainWindow.h"

namespace Ui {
class CruMainWindow;
}

class FeLinkTreeModel;
class RunLogicWidget;
class TrigCtrlStatWidget;

class CruMainWindow : public ReadoutAppMainWindow
{
    Q_OBJECT

public:
    explicit CruMainWindow(QWidget *parent = nullptr);
    ~CruMainWindow();

    DeviceStatusTableViewFancy *getDeviceStatusTableView() override;
    RunLogicWidget *getRunLogicWidget() const;
    TrigCtrlStatWidget *getTrigCtrlStatWidget() const;

signals:
    void printFsmInputs() const;
    void performLocalStart() const;
    void performLocalStop() const;

public slots:
    void setConfig(const ConfigKey &key, const BaseDeviceAppConfig &_config) override;
    void setShowRunLogic(bool show);
    void modelReseted();

private slots:
    void on_radioButtonOpen_toggled(bool open);

protected:
    void updateControlState() override;

private:
    void updateRunLogicVisiblity() const;

    Ui::CruMainWindow *ui;

    bool showRunLogic = false; // desirable state from Options menu
};

#endif // CRUMAINWINDOW_H
