#ifndef REORGANIZATIONDIALOG_H
#define REORGANIZATIONDIALOG_H

#include <QDialog>
#include <QMap>

namespace Ui {
class ReorganizationDialog;
}

class ReorganizationDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ReorganizationDialog(QMap<quint32, QPair<int,int> > p, QWidget *parent = 0);
    ~ReorganizationDialog();
    QMap<quint32, QPair<int,int> > getPlaces() const { return places; }
private slots:
    void boxCurrentIndexChanged(int index);
    void on_spinBoxRows_valueChanged(int rows);
    void on_spinBoxColumns_valueChanged(int columns);

private:
    Ui::ReorganizationDialog *ui;
    QMap<quint32, QPair<int,int> > places; // <row, column>
    QMap<quint64, QString> elements;
    int rowCount; // instead of ui->gridLayout->rowCount() (reserved rows)
    int columnCount;
};

#endif // REORGANIZATIONDIALOG_H
