#ifndef HRBSIGNALROUTER_H
#define HRBSIGNALROUTER_H


class ConfigurationManager;
class MStreamDeviceMgrFsm;
class HrbConfigDb;
class HrbConfigDispatcher;
class DeviceDispatcher;
class EvNumChecker;
class HrbMainWindow;
class HrbCore;
class RemoteControlServer;
class HrbDeviceGlobal;
class TtbDeviceGlobal;
class MStreamStatisticDialog;
class StatisticDialog;
class DiscoverDialog;
class HrbModel;
class TtbModel;

class HrbSignalRouter
{
    HrbSignalRouter() = default;
public:
    static HrbSignalRouter & instance()
    {
        static HrbSignalRouter obj;
        return obj;
    }

    void setConfigurationManager(ConfigurationManager *p)
    { configurationManager = p; }
    void setCore(HrbCore *p)
    { core = p; }
    void setEvNumChecker(EvNumChecker *p)
    { evNumChecker = p; }
    void setMainWindow(HrbMainWindow *p);
    void setStatisticDialog(StatisticDialog *p)
    { statisticDialog = p; }
    void setMStreamStatisticDialog(MStreamStatisticDialog *p)
    { mStreamStatisticDialog = p; }
    void setDiscoverDialog(DiscoverDialog *p)
    { discoverDialog = p; }
    void setDeviceDispatcher(DeviceDispatcher *p)
    { deviceDispatcher = p;}
    void setConfigDb(HrbConfigDb *p)
    { configDb = p; }
    void setRemoteControlServer(RemoteControlServer *p)
    { remoteControlServer = p; }
    void setFsm(MStreamDeviceMgrFsm *p)
    { fsm = p; }
    void setHrbModel(HrbModel *p)
    { hrbModel = p; }
    void setTtbModel(TtbModel *p)
    { ttbModel = p; }


    void connectAll();
    void connect_DeviceGlobal(const HrbDeviceGlobal * devGlob);
    void connect_DeviceGlobal(const TtbDeviceGlobal * devGlob);

private:
    void connect_ConfigurationDispatcher();
    void connect_deviceDispatcher();
    void connect_HrbMainWindow();
    void connect_PnpServer();
    void connect_RemoteControlServer();
    void connect_FSM();
    void connect_EvNumChecker();

    ConfigurationManager *configurationManager = nullptr;
    MStreamDeviceMgrFsm *fsm = nullptr;
    HrbConfigDb * configDb = nullptr;
    HrbConfigDispatcher * configDispatcher = nullptr;
    DeviceDispatcher * deviceDispatcher = nullptr;
    HrbMainWindow *mainWindow = nullptr;
    HrbCore *core = nullptr;
    RemoteControlServer *remoteControlServer = nullptr;
    EvNumChecker *evNumChecker = nullptr;
    StatisticDialog *statisticDialog = nullptr;
    MStreamStatisticDialog *mStreamStatisticDialog = nullptr;
    DiscoverDialog *discoverDialog = nullptr;
    HrbModel *hrbModel = nullptr;
    TtbModel *ttbModel = nullptr;
};
#endif // HRBSIGNALROUTER_H
