#ifndef MONGOVIEWERCONFIGDISPATCHER_H
#define MONGOVIEWERCONFIGDISPATCHER_H

#include <QObject>

class MongoViewerConfig;

class MongoViewerConfigDispatcher : public QObject
{
    Q_OBJECT
public:
    MongoViewerConfigDispatcher(QObject *parent = nullptr);
    virtual ~MongoViewerConfigDispatcher();

    template<class T>
    void subscribe(T *obj) {
        connect(obj, &T::configChanged,
                this, &MongoViewerConfigDispatcher::setConfig);
        connect(this, &MongoViewerConfigDispatcher::configChanged,
                obj, &T::setConfig);
    }

signals:
    void configChanged(const MongoViewerConfig &);

public slots:
    void setConfig(const MongoViewerConfig &config);

private:
    MongoViewerConfig * const cache;
};

#endif // MONGOVIEWERCONFIGDISPATCHER_H
