#include "RunControl.h"
#include "ui_RunControl.h"

RunControl::RunControl(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::RunControl)
{
    ui->setupUi(this);
    connect(ui->pushButtonStart, &QPushButton::clicked,
            this, &RunControl::startLocalRun);
    connect(ui->pushButtonStop, &QPushButton::clicked,
            this, &RunControl::stopLocalRun);
}

RunControl::~RunControl()
{
    delete ui;
}

void RunControl::onStateChanged(const FsmState &cur) const
{
    ui->pushButtonStarted->setChecked(cur == FsmState::Run);
    ui->pushButtonStarting->setChecked(cur == FsmState::Configure ||
                                       cur == FsmState::Starting);
    ui->pushButtonStopped->setChecked(cur == FsmState::Ready);
    ui->pushButtonStopping->setChecked(cur == FsmState::Stopping ||
                                       cur == FsmState::PrepareStopping);
    ui->pushButtonError->setChecked(cur == FsmState::Error);

    ui->pushButtonStart->setEnabled(cur == FsmState::Ready);
    ui->pushButtonStop->setEnabled(cur == FsmState::Run);
}
