#ifndef MSCTHRESHOLDDIALOG_H
#define MSCTHRESHOLDDIALOG_H

#include "lib-common/BaseDeviceAppConfig.h"

#include <QDialog>
#include <optional>

class ConfigKey;
class MscThresholdModel;

namespace Ui {
    class MscThresholdDialog;
}

class MscThresholdDialog : public QDialog
{
    Q_OBJECT
public:
    explicit MscThresholdDialog(QWidget *parent = nullptr);
    ~MscThresholdDialog() override;

    void setModel(MscThresholdModel *model);

signals: void configChanged(const BaseDeviceAppConfig &config);
public slots: void setConfig(const ConfigKey &config_key, const BaseDeviceAppConfig &newConfig);

private:
    Ui::MscThresholdDialog *ui;
    std::optional<BaseDeviceAppConfig> config;
    bool write_request_flag;
};

#endif // MSCTHRESHOLDDIALOG_H
