#ifndef MscStatus_H
#define MscStatus_H

#include <QMetaType>
#include <optional>

#include "ModularDeviceStatus.h"
#include "device-modules/Ddr3StreamFifo/Ddr3StreamFifoStatus.h"
#include "device-modules/MscCycleCounters/MscCycleStatus.h"
#include "device-modules/MscHist/MscHistStatus.h"
#include "device-modules/MscInput/MscInputStatus.h"

class MscStatus: public ModularDeviceStatus
{
public:
    explicit MscStatus(const DeviceIndex &deviceIndex = {})
        : ModularDeviceStatus(deviceIndex) {}

    friend bool operator==(const MscStatus &, const MscStatus &) = default;

    std::optional<Ddr3StreamFifoStatus> ddrStatus;
    std::optional<MscInputStatus> inputStatus;
    std::optional<MscCycleStatus> cycleStatus;
    std::optional<MscHistStatus> histStatus;
};
Q_DECLARE_METATYPE(MscStatus)

#endif // MscStatus_H
