/*
**    Copyright 2014-2015 Ivan Filippov
**    Copyright 2014-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef VMETRIGDEVICE_H
#define VMETRIGDEVICE_H

#include "VmeTrigStatus.h"
#include "ModularMregDevice.h"

class ConfigKey;

class VmeTrigDevice : public ModularMregDevice
{
    Q_OBJECT
public:
    explicit VmeTrigDevice(const DeviceIndex &deviceIndex, QObject *parent = nullptr);

signals:
    void updateStatus(const DeviceIndex &deviceIndex, const VmeTrigStatus &status);

public slots:
    bool readStatus() override;
    void vmeReadoutUpdated(const DeviceIndex &deviceIndex, bool _evNumRead);
    void evNumRequest(int checkIndex) override;

private:
    bool readVmeTrigStatus();
    std::optional<quint64> readGlobEvNum();

    VmeTrigStatus status;
    bool doEvNumRead = true;
};

#endif // VMETRIGDEVICE_H
