#ifndef CALIBRATIONTRIGGERWIDGET_H
#define CALIBRATIONTRIGGERWIDGET_H

#include <QGroupBox>

class CalibrationTriggerWidgetPrivate;
namespace Ui {
class CalibrationTriggerWidget;
}
struct CalibrationTriggerConfig;

class CalibrationTriggerWidget : public QGroupBox
{
    Q_OBJECT

public:
    explicit CalibrationTriggerWidget(QWidget *parent = nullptr);
    ~CalibrationTriggerWidget() override;
    void setConfig(const CalibrationTriggerConfig &c);

signals:
    void cfgUpdated(const CalibrationTriggerConfig &cfg) const;

private slots:
    void on_checkBoxEn_toggled(bool en);
    void on_spinBoxPeriod_valueChanged(int p);
    void on_spinBoxCount_valueChanged(int c);
    void on_spinBoxOffset_valueChanged(int o);


private:
    void restoreGui() const;

    Ui::CalibrationTriggerWidget *ui;
    Q_DECLARE_PRIVATE(CalibrationTriggerWidget)
    QScopedPointer<CalibrationTriggerWidgetPrivate> const d_ptr;
};

#endif // CALIBRATIONTRIGGERWIDGET_H
