#include "SnmpDialog.h"
#include "ui_SnmpDialog.h"

#include <QDebug>
#include <QSettings>

#include "SnmpCtrl.h"
#include "ttvxs_snmp_types.h"




SnmpDialog::SnmpDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::SnmpDialog),
    connected(false),
    snmp(new SnmpCtrl())
{
    ui->setupUi(this);

//    int val = snmp->add_mib_dir("/home/daq/.snmp/mibs");
//    snmp->check_mib();

    load_cfg();
    ui->lineEditAddr->setText(config.addr);
//    connect_to_snmp();
}

SnmpDialog::~SnmpDialog()
{
    save_cfg();
    delete ui;
}

void SnmpDialog::on_pushButtonConnect_clicked()
{
    if(connected) {
        disconnect_from_snmp();
    } else {
        connect_to_snmp();
    }
}

void SnmpDialog::status_poll()
{
    long val_int;
    bool ok;
    QString val_str;
    ok = snmp->get_int(sensorsVoltageNom_8, &val_int);
    ok = snmp->get_str(SYS_FIRMWARE_NAME_OID, &val_str);
    snmp->debug_print(".1.3.6.1.4.1.53776.120.1.3.3.1.1.6.1");
    snmp->debug_print(".1.3.6.1.4.1.53776.120.1.3.3.1.1.6");
    QVector<QPair<QString, QVariant> > responce;
//    responce.first().second.type();
    snmp->print_test_dec();
    snmp->print_test2(QStringList() << sensorsVoltageNom_8<< sensorsVoltageNom_8<<SYS_FIRMWARE_NAME_OID, &responce);

    qInfo() << responce;
    qDebug() << "SnmpDialog::status_poll(): " << ok;
}

void SnmpDialog::load_cfg()
{
    QSettings s;
    s.beginGroup("SNMP");
    config.addr = s.value("addr").toString();
    config.serial = s.value("serial").toUInt();
    s.endGroup();
}

void SnmpDialog::save_cfg()
{
    QSettings s;
    s.beginGroup("SNMP");
    s.setValue("addr", config.addr);
    s.setValue("serial", config.serial);
    s.endGroup();
}

bool SnmpDialog::connect_to_snmp()
{
    config.addr = ui->lineEditAddr->text();
//    connected = connect_to_snmp(addr);
    connected = true;
    snmp->setHost(config.addr);
    snmp->setCommunity("public");
    status_poll();
    update_button_label();
    return connected;
}

void SnmpDialog::disconnect_from_snmp()
{
    snmp->disconnect();
    connected = false;
    update_button_label();
}

void SnmpDialog::update_button_label()
{
    ui->pushButtonConnect->setText(connected ? "Disconnect" : "Connect");
    ui->lineEditAddr->setEnabled(!connected);
}
