#include "TtvxsConfigDb.h"
#include "base/AbstractConfigConverter.h"

#include <QJsonDocument>

TtvxsConfigDb::TtvxsConfigDb(QObject *parent) :
    AbstractConfigDb(parent)
{
    AbstractConfigConverter<RunControlAppConfig>::registerTypes();
}

void TtvxsConfigDb::setConfig(const ConfigKey &config_key, const RunControlAppConfig &newConfig)
{
    Q_UNUSED(config_key);
    if(!initialized)
        return;
    if (newConfig == config)
        return;
    config = newConfig;
    emit configChanged(config);
    const auto &json = QVariant::fromValue(config).value<QJsonObject>();
    write_config(json);
}

void TtvxsConfigDb::update_config_from_db()
{
    const auto &json = readConfig(cs);
    auto newConfig = QVariant::fromValue(json).value<RunControlAppConfig>();
    newConfig.setRunState(false);
    newConfig.unify_config();
    newConfig.removeInvalidEntries();
    emit configChanged(newConfig);
}
