#include "ConfigOidConverter.h"

#include "ConfigOid.h"

namespace {
inline constexpr const char *k_oid = "$oid";
}

template<>
bool AbstractConfigConverter<ConfigOid>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<ConfigOid>::toJsonObject(const ConfigOid &in)
{
    QVariantMap m;
    m[k_oid] = in;
    return fromVariantMap(m);
}

template<>
ConfigOid AbstractConfigConverter<ConfigOid>::fromJsonObject(const QJsonObject &json)
{
    auto config_oid = json[k_oid].toString();
    return ConfigOid(config_oid);
}

template<>
QJsonValue AbstractConfigConverter<ConfigOid>::toJsonValue(const ConfigOid &in)
{
    return toJsonObject(in);
}

template<>
ConfigOid AbstractConfigConverter<ConfigOid>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<ConfigOid>::registerSubTypes()
{
}
