/*
**    Copyright 2009-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DSPLIB_FITTERBASE_H
#define DSPLIB_FITTERBASE_H

namespace dsplib {

typedef struct fitstatus_t {
    int niter = 0;
    double fnorm = 0;
    //  double err[3] = {};
} fitstatus_t;

class FitterBase
{
public:
    FitterBase() = delete;
    FitterBase(const FitterBase &) = delete;
    explicit FitterBase (unsigned int fit_points);
    FitterBase &operator=(const FitterBase &) = delete;
    ~FitterBase ();

    unsigned int getMaxFitPoints () const;

protected:
    struct lm_ws_t *ws = nullptr;
};

} // namespace dsplib

#endif // DSPLIB_FITTERBASE_H
