/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "DeviceIndexTableModel.h"
#include "base/DeviceIndex.h"

//DeviceIndex DeviceIndexTableModel::deviceIndexOf(const QModelIndex &index) const
//{
//    if (! index.isValid())
//        return {};
//    return deviceIndexOf(index.row());
//}

void DeviceIndexTableModel::invalidateRow(const DeviceIndex &deviceIndex)
{
    int row = rowOf(deviceIndex);
    if (row == -1)
        return;

    auto indexFrom = createIndex(row, 0);
    auto indexTo = createIndex(row, columnCount()-1);
    emit dataChanged(indexFrom, indexTo);
}

QVariant DeviceIndexTableModel::headerData(int section, Qt::Orientation orientation, int role) const
{
    if (orientation == Qt::Vertical) {
        if (role == Qt::UserRole) {
            const auto &deviceIndex = deviceIndexOf(section);
            return QVariant::fromValue(deviceIndex);
        }
        return {};
    }
    return {};
}
