/*
**    Copyright 2015-2022 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SPILLPLOT_H
#define SPILLPLOT_H

#include <QList>
#include <QWidget>

namespace Ui {
class SpillPlot;
}

struct SpillPlotData;
class WaveformPlot;

class SpillPlot : public QWidget
{
    Q_OBJECT

public:
    explicit SpillPlot(QWidget *parent = nullptr);
    ~SpillPlot();

public slots:
    void updateSpillPlot(const SpillPlotData &shd);

private slots:
    void checkForReplot();

private:
    void scheduleReplot();
    void performReplot();

    Ui::SpillPlot *ui;
    WaveformPlot *plot;
    QList<SpillPlotData> history;
    bool replot = true;
};

#endif // SPILLPLOT_H
