#ifndef MLDPLISTENER_H
#define MLDPLISTENER_H

#include <QObject>
#include <QMetaType>

#include "base/DeviceIndex.h"
#include "LldpInfo.h"

class MultiCastListener;
class QHostAddress;

class MldpListener : public QObject
{
    Q_OBJECT
public:
    explicit MldpListener(QObject *parent = nullptr);
    explicit MldpListener(const QHostAddress &_host, quint16 _port, QObject *parent = nullptr);

signals:
    void receivedLldpInfo(const LldpInfo &) const;

public slots:
    void setDeviceIdFilter(const DeviceIdSet &filter) { deviceIdFilter = filter; }

private slots:
    void analyzeData(const QByteArray &data, const QHostAddress &host) const;
    static LldpInfo decodeData(const QByteArray &data, const QHostAddress &host, bool *ok = nullptr);

private:
    void send_info(const LldpInfo &lldp) const;

    MultiCastListener * const rawListener;
    DeviceIdSet deviceIdFilter;
};

#endif // MLDPLISTENER_H
