#include "AdcSpiBaseModule.h"

#include <QDebug>
#include <QElapsedTimer>

bool AdcSpiBaseModule::spi_test()
{
    QElapsedTimer t;
    t.start();
    TestResult testResult;
    for (int loop = 0; loop < 10; loop++) {
        if (!spi_test_impl(&testResult))
            goto err;
        if (!testResult.isOk())
            break;
    }
    if (testResult.isOk())
        qDebug() << __func__ << "passed in" << t.elapsed() << "ms";
    else
        qWarning() << __func__ << "failed";
    return testResult.isOk();
err:
    qWarning() << __func__ << "I/O error";
    return false;
}
