#ifndef ADCSERDESDELAY_H
#define ADCSERDESDELAY_H

#include <QMap>
#include <QMetaType>

#include "base/DeviceIndex.h"

struct AdcSerDesDelay
{
    AdcSerDesDelay() = default;
    AdcSerDesDelay(int clock, int data) : clock(clock), data(data) {}
    friend bool operator==(const AdcSerDesDelay &l, const AdcSerDesDelay &r) = default;
    int clock = 0;
    int data = 0;
};
Q_DECLARE_METATYPE(AdcSerDesDelay)

QDebug operator<<(QDebug dbg, const AdcSerDesDelay &s);
QDataStream &operator<<(QDataStream &out, const AdcSerDesDelay &r);
QDataStream &operator>>(QDataStream &in, AdcSerDesDelay &r);

class AdcSerDesDelayMap
{
public:
    friend bool operator==(const AdcSerDesDelayMap &, const AdcSerDesDelayMap &) = default;
    QMap<int, AdcSerDesDelay> map;
};
Q_DECLARE_METATYPE(AdcSerDesDelayMap)

class DevSerDesDelayMap
{
public:
    friend bool operator==(const DevSerDesDelayMap &, const DevSerDesDelayMap &) = default;
    QMap<DeviceIndex, AdcSerDesDelayMap> map;
};
Q_DECLARE_METATYPE(DevSerDesDelayMap)

#endif // ADCSERDESDELAY_H
