/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DLNPCALIBRATIONTRIGGERCONFIG_H
#define DLNPCALIBRATIONTRIGGERCONFIG_H

#include <QMetaType>

class QDataStream;
class QDebug;

struct DlnpCalibrationTriggerConfig
{
    DlnpCalibrationTriggerConfig() = default;
    DlnpCalibrationTriggerConfig(const DlnpCalibrationTriggerConfig&) = default;
    DlnpCalibrationTriggerConfig &operator=(const DlnpCalibrationTriggerConfig&) = default;
    friend bool operator==(const DlnpCalibrationTriggerConfig &, const DlnpCalibrationTriggerConfig &) = default;
    bool en = false;
    quint32 period = 0; // in clocks
    quint16 count = 0;
    quint32 offset = 0; // in clocks
};
Q_DECLARE_METATYPE(DlnpCalibrationTriggerConfig)

QDebug operator<<(QDebug dbg, const DlnpCalibrationTriggerConfig &s);
QDataStream &operator<<(QDataStream &out, const DlnpCalibrationTriggerConfig &r);
QDataStream &operator>>(QDataStream &in, DlnpCalibrationTriggerConfig &r);

#endif // DLNPCALIBRATIONTRIGGERCONFIG_H
