#ifndef FELINKDEVICEUTIL_H
#define FELINKDEVICEUTIL_H

#include <QtCore>
#include <optional>

namespace mlink {
class RegOpVector;
}
struct FeLinkChConfig;
struct FeLinkStatus;
struct FeLinkBuildParams;

mlink::RegOpVector getStatusLockROV(bool block);
mlink::RegOpVector getFeLinkStatusROV(int ch);
mlink::RegOpVector getFeLinkStatusROV_v2(quint16 baseAddr);
FeLinkStatus getFeLinkStatus(const mlink::RegOpVector &regRes, int shift);
FeLinkStatus getFeLinkStatus_v2(const mlink::RegOpVector &regRes, int shift);

mlink::RegOpVector getWriteChConfigROV_v2(quint16 baseAddr, const FeLinkChConfig &cfg);
mlink::RegOpVector getPhyLevelCtrlRegsROV(const FeLinkBuildParams &bp);
QVector<quint16> getPhyLevelCtrlRegs(const mlink::RegOpVector &regRes);
mlink::RegOpVector selfReleasePhyResetUtil(const QVector<quint16> &regs,
                                           const FeLinkBuildParams &bp,
                                           int ch);

mlink::RegOpVector getFeLinkBuildParamsROV();
std::optional<FeLinkBuildParams> getFeLinkBuildParams(const mlink::RegOpVector &regRes);


#endif // FELINKDEVICEUTIL_H
