#ifndef FELINKSTATUSMODULE_H
#define FELINKSTATUSMODULE_H

#include <optional>
#include "device-modules/BaseDeviceModule.h"

#include "FeLinkBuildParams.h"

struct FeLinkConfig;
struct FeLinkStatus;

using FeLinkStatusMap = QMap<int,FeLinkStatus>;

class FeLinkStatusModule : public BaseDeviceModule<FeLinkStatusModule>
{
public:
    explicit FeLinkStatusModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;

    std::optional<FeLinkBuildParams> getBuildParams() { return buildParams; }
    std::optional<FeLinkStatusMap> readStatus();
    bool writeConfig(const FeLinkConfig &feLink);
    bool phyReset(int resetCh = -1);

protected:
    std::optional<FeLinkStatusMap> readStatus_v1();
    std::optional<FeLinkStatusMap> readStatus_v2();
    virtual int getFeLinkCnt() const;
    std::optional<FeLinkBuildParams> buildParams;
};

#endif // FELINKSTATUSMODULE_H
