#include "MscHistConfigConverter.h"
#include "MscHistConfig.h"
#include "base/ConfigConverterUtil.h"

namespace {
    constexpr const char *k_name = "name";
    constexpr const char *k_enable = "enable";
    constexpr const char *k_plot_slice = "plot_slice";
}

template<>
bool AbstractConfigConverter<MscHistIdConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<MscHistIdConfig>::toJsonObject(const MscHistIdConfig &in)
{
    QVariantMap m;
    m[k_name] = QVariant::fromValue(in.name);
    m[k_enable] = QVariant::fromValue(in.enable);
    m[k_plot_slice] = QVariant::fromValue(in.plotSlice);
    return fromVariantMap(m);
}

template<>
MscHistIdConfig AbstractConfigConverter<MscHistIdConfig>::fromJsonObject(const QJsonObject &in)
{
    MscHistIdConfig out;
    update_value(in, k_name, &out.name);
    update_value(in, k_enable, &out.enable);
    update_value(in, k_plot_slice, &out.plotSlice);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<MscHistIdConfig>::toJsonValue(const MscHistIdConfig &in)
{
    return toJsonObject(in);
}

template<>
MscHistIdConfig AbstractConfigConverter<MscHistIdConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<MscHistIdConfig>::registerSubTypes()
{}
