#ifndef MSCSTREAMMODULE_H
#define MSCSTREAMMODULE_H

#include "device-modules/BaseDeviceModule.h"

struct MscStreamConfig;

class MscStreamModule : public BaseDeviceModule<MscStreamModule>
{
public:
    explicit MscStreamModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const MscStreamConfig &cfg);

private:
    mlink::RegOpVector setConfigRegOp(const MscStreamConfig &cfg);
    inline quint16 getControlReg(const MscStreamConfig &cfg) const;
    quint16 getCeMonitorMask(const MscStreamConfig &cfg) const;
};
#endif // MSCSTREAMMODULE_H
