#ifndef SPILLCONTROLMODULE_H
#define SPILLCONTROLMODULE_H

#include "device-modules/BaseDeviceModule.h"
#include <optional>

struct SpillStatus;
struct SpillConfig;

class SpillControlModule : public BaseDeviceModule<SpillControlModule>
{
public:
    explicit SpillControlModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const SpillConfig &config);
    bool readStatus(SpillStatus *status);
    std::optional<SpillStatus> readStatus();

protected:
    static mlink::RegOpVector setConfigRegOp(const SpillConfig &spill);
    static mlink::RegOpVector getStatusRegOp(SpillStatus *st);
};

#endif // SPILLCONTROLMODULE_H
