#ifndef TTLIOMODULE_H
#define TTLIOMODULE_H

#include "device-modules/BaseDeviceModule.h"

struct TtlIoConfig;

class TtlIoModule : public BaseDeviceModule<TtlIoModule>
{
public:
    explicit TtlIoModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    virtual void post_init() override;
    TtlIoConfig readConfig();
    bool writeConfig(const TtlIoConfig &cfg);

private:
    mlink::RegOpVector setConfig(const TtlIoConfig &cfg) const;

    quint16 ttlCount = 0;
};

#endif // TTLIOMODULE_H
