/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef WAVEBLCSTATUS_H
#define WAVEBLCSTATUS_H

#include <QMap>
#include <QMetaType>

class WaveBlcStatus
{
public:
    enum ChannelRegArray {RawData, StaticOffset, Settings, LoThr, HiThr};
    friend bool operator==(const WaveBlcStatus &, const WaveBlcStatus &) = default;
    bool isValid() const;

    quint32 id = 0;
    quint16 channelCount = 0;
    QMap<ChannelRegArray, quint16> arrayAddress;
};
Q_DECLARE_METATYPE(WaveBlcStatus)

#endif // WAVEBLCSTATUS_H
