#include "AdcBaselineCalibration.h"

#include "device-modules/WaveRec/WaveRecModule.h"

const int CALIBRATE_LIMIT = 10e3;

AdcBaselineCalibration::AdcBaselineCalibration(WaveRecModule *_adcCor)
    : waveRec(_adcCor)
{
}

bool AdcBaselineCalibration::calibrateBaseline(MultichannelBaselineStats *result)
{
    if (!waveRec->readBaseline(result, CALIBRATE_LIMIT)) {
        qWarning() << "error in getting current adc value while calibration";
        return {};
    }
    return true;
}
