#ifndef ADCDESERCHECKSTATUS_H
#define ADCDESERCHECKSTATUS_H

#include <QMap>
#include <QMetaType>
#include <QSet>

struct AdcDeserCheckStatus {
    static const QPair<int, int> NULL_POINT;
    enum class Status {Ok, Warning, Error};

    friend bool operator==(const AdcDeserCheckStatus &, const AdcDeserCheckStatus &) = default;
    Status getStatus() const {
        auto ret = Status::Ok;
        for(auto it = failedDes.cbegin(); it != failedDes.cend(); ++it) {
            if(it.key() == NULL_POINT) {
                if(!it->isEmpty())
                    return Status::Error;
                else if(ret == Status::Warning)
                    break;
            } else {
                if(ret != Status::Warning && !it->isEmpty())
                    ret = Status::Warning;
            }
        }
        return ret;
    }

    QMap<QPair<int,int>, QSet<int> > failedDes;
};
Q_DECLARE_METATYPE(AdcDeserCheckStatus)

#endif // ADCDESERCHECKSTATUS_H
