#ifndef CROSSPOINTSWITCHDILOG_H
#define CROSSPOINTSWITCHDILOG_H

#include <QDialog>
#include <QMap>
#include <optional>

#include "base/DeviceIndex.h"
#include "CrosspointSwitch/CrosspointSwitchBuildParams.h"
#include "CrosspointSwitch/CrosspointSwitchConfig.h"

class QComboBox;
class QLayout;

namespace Ui {
class CrosspointSwitchDilog;
}

class CrosspointSwitchDilog : public QDialog
{
    Q_OBJECT

public:
    explicit CrosspointSwitchDilog(QWidget *parent = nullptr);
    ~CrosspointSwitchDilog();

signals:
    void crosspointSwitchConfigChanged(const CrosspointSwitchConfig &) const;

public slots:
    void crosspointSwitchBpUpdated(const DeviceIndex &, const CrosspointSwitchBuildParams &bp);
    virtual void setCrosspointSwitchConfig(const CrosspointSwitchConfig &config);
private slots:
    void cbCurrentIndexChanged();
    void on_pushButtonResetAfterDsp_clicked();
    void on_pushButtonResetRaw_clicked();

private:
    quint16 getOutSize() const;
    quint16 getInputSize() const;
    void updateGui();
    void updateCb(bool typeWf, quint16 index) const;
    QComboBox *createCb(bool typeWf, quint16 index) const;
    void updateCbItems(QComboBox *cb) const;
    void adoptCfgToBp();
    CrosspointSwitchConfig getConfigAfterDsp() const;
    CrosspointSwitchConfig getConfigBeforeDsp() const;
    QComboBox* getCb(QLayout *l, int row) const;

    Ui::CrosspointSwitchDilog *ui;
    std::optional<CrosspointSwitchBuildParams> buildParams;
    std::optional<CrosspointSwitchConfig> config;
    QVector<QComboBox*> boxList;
};

#endif // CROSSPOINTSWITCHDILOG_H
