#ifndef SETFIRFILTERDIALOG_H
#define SETFIRFILTERDIALOG_H

#include "FirFilter/FirFilterConfig.h"
#include <QDialog>

class QAbstractButton;
class QTableWidgetItem;

namespace Ui {
class SetFirFilterDialog;
}

class SetFirFilterDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SetFirFilterDialog(const FirFilterConfig &cfg, QWidget *parent = nullptr);
    ~SetFirFilterDialog();
    FirFilterConfig getConfig() const { return config; }
    void setSizeLimit(int size);

signals:
    void firFilterConfigChanged(const FirFilterConfig &config);

public slots:
    void setFirFilterConfig(const FirFilterConfig &newConfig);

private slots:
    void on_groupBox_toggled(bool en);
    void on_spinBoxSize_valueChanged(int size);
    void on_tableWidget_itemChanged(QTableWidgetItem *item);
    void on_buttonBox_clicked(QAbstractButton *button);

    void coefChanged(int val);

    void on_pushButton_clicked();

private:
    void updateGui();
    void updateDouble(int r);

    Ui::SetFirFilterDialog *ui;
    FirFilterConfig config;
};

#endif // SETFIRFILTERDIALOG_H
