/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef WAVEBLCWIDGET_H
#define WAVEBLCWIDGET_H

#include "WaveBlc/WaveBlcConfig.h"
#include <QWidget>

namespace Ui {
class WaveBlcWidget;
}

class WaveBlcWidget : public QWidget
{
    Q_OBJECT

public:
    explicit WaveBlcWidget(QWidget *parent = nullptr);
    ~WaveBlcWidget();

signals:
    void waveBlcConfigChanged(const WaveBlcConfig &config);

public slots:
    void setWaveBlcConfig(const WaveBlcConfig &newConfig);

private slots:

    void on_comboBoxMafLength_currentIndexChanged(int index);
    void on_comboBoxMode_currentIndexChanged(int index);
    void on_comboBoxPolarity_currentIndexChanged(int index);
    void on_spinBoxThreshold_valueChanged(int arg1);
    void on_spinBoxTruncate_valueChanged(int arg1);
    void on_spinBoxCommonOffset_valueChanged(int arg1);

private:
    void restoreGuiFromConfig();

    Ui::WaveBlcWidget *ui;
    WaveBlcConfig config;
};

#endif // WAVEBLCWIDGET_H
