//
//    Copyright 2016 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef METRICSENDERHELPER_H
#define METRICSENDERHELPER_H

#include <QObject>
#include <QUrl>
#include <QHostAddress>

#include "MetricTypes.h"

class MetricSenderHelper : public QObject
{
    Q_OBJECT
public:
    explicit MetricSenderHelper(QObject *parent = nullptr);
    static MetricTags defaultTags();
    QString formatMetricLine(const MetricEntity &ent);
    void setBaseTag(const QString &key, const QString &value) { baseTags[key] = value; }
    void setBaseTags(const MetricTags &s) { baseTags = s; }
    bool isEnabled() const { return enable; }
    QHostAddress hostAddr() const;
    quint16 hostPort() const;
    QUrl getUrl() const;

signals:

public slots:
protected:
    MetricTags baseTags;
    QUrl url;
    bool enable;
    QHostAddress hostAddrCached;
};

#endif // METRICSENDERHELPER_H
