#include "ZmqConfigConverter.h"

namespace {
constexpr const char *k_auto_port = "auto_port";
constexpr const char *k_port = "port";
constexpr const char *k_enabled = "enabled";
constexpr const char *k_test_mode = "test_mode";
constexpr const char *k_print_messages = "print_messages";
}

template<>
bool AbstractConfigConverter<ZmqConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<ZmqConfig>::toJsonObject(const ZmqConfig &in)
{
    QVariantMap m;
    m[k_auto_port] = QVariant::fromValue(in.auto_port);
    m[k_port] = QVariant::fromValue(in.port);
    m[k_enabled] = QVariant::fromValue(in.enabled);
    m[k_test_mode] = QVariant::fromValue(in.test_mode);
    m[k_print_messages] = QVariant::fromValue(in.print_messages);

    return fromVariantMap(m);
}

template<>
ZmqConfig AbstractConfigConverter<ZmqConfig>::fromJsonObject(const QJsonObject &in)
{
    ZmqConfig out;
    update_value(in, k_auto_port, &out.auto_port);
    update_value(in, k_port, &out.port);
    update_value(in, k_enabled, &out.enabled);
    update_value(in, k_test_mode, &out.test_mode);
    update_value(in, k_print_messages, &out.print_messages);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<ZmqConfig>::toJsonValue(const ZmqConfig &in)
{
    return toJsonObject(in);
}

template<>
ZmqConfig AbstractConfigConverter<ZmqConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<ZmqConfig>::registerSubTypes()
{}
