#ifndef ZMQPUBLISHER_H
#define ZMQPUBLISHER_H

#include <QObject>

#include "ZmqTypes.h"

namespace zmq{
class context_t;
class socket_t;
}

class QTimer;


class ZmqPublisher : public QObject
{
    Q_OBJECT
public:
    explicit ZmqPublisher(QObject *parent = nullptr);
    int getPort() const { return status.port; }
    virtual ~ZmqPublisher() override;

signals:
    void statusUpdated(const ZmqStatus &s) const;
    void zmqConfigChanged(const ZmqConfig &) const;

private slots:
    void test_send();
    void send_status();

public slots:
    void setZmqConfig(const ZmqConfig &config);
    void publish(const QString &str);
    void clearStat();

private:
    bool createSocket();
    void closeSocket();
    bool connectMonitor();
    int get_monitor_event (void *monitor, int *value, char **address);
    QString eventStr(int evNum) const;

    QTimer * const test_timer;
    QTimer * const status_timer;
    zmq::context_t * context = nullptr;
    int test_id = 0;

protected:
    ZmqConfig cfg;
    ZmqStatus status;

    zmq::socket_t * socket = nullptr;
    zmq::socket_t * socket_mon = nullptr;
};

#endif // ZMQPUBLISHER_H
